---
---
$gap: 8px;

body {
   display: flex;
   justify-content: center;
   align-items: center;
   position: relative;
   backdrop-filter: blur(50px); /* needs explicit enabling in Firefox
                                   -- layout.css.backdrop-filter.enabled */
}

body::before {
   content: '';
   position: absolute;
   z-index: 1;
   left: 0; right: 0;
   top: 0; bottom: 0;
   background-color: rgba(0,0,0,0.5);
}

.app-grid {
   z-index: 10;
   max-width: 80vw;
   display: grid;
   justify-items: center;
   grid-template-columns: repeat(6,1fr);
   grid-template-rows: repeat(4,1fr);
   grid-column-gap: 4vw;
   grid-row-gap: 4vh;
   /* wishful thinking
   transition: grid-template-rows 300ms ease-out,
               grid-template-columns 300ms ease-out
   */


   .app {
      padding: $gap $gap*3 $gap*4 ;
      border-radius: $gap;
      position: relative;

      &:hover {
         background-color: rgba(255,255,255,0.3);
         cursor: pointer;
      }
      .label {
         position: absolute;
         bottom: $gap; left: 0; right: 0;
         text-align: center;
      }

      img {
         object-fit: contain;
         width: 100%;
         height: auto;
         min-width: 96px;
      }
   }
}



/* medium wide layout wants 6:4 */
@media only screen and (min-aspect-ratio: 4/3) {
   .app-grid {
      grid-template-columns: repeat(6,1fr);
      grid-template-rows: repeat(4,1fr);
   }
}

/* super wide wants 8:3 */
@media only screen and (min-aspect-ratio: 16/9) {
   .app-grid {
      grid-template-columns: repeat(8,1fr);
      grid-template-rows: repeat(3,1fr);
   }
}

/* portrait layout wants 4:6 */
@media only screen and (max-aspect-ratio: 3/4) {
   .app-grid {
      grid-template-columns: repeat(4,1fr);
      grid-template-rows: repeat(6,1fr);
   }
}

/* wider  3:8 */
@media only screen and (max-aspect-ratio: 9/16) {
   .app-grid {
      grid-template-columns: repeat(3,1fr);
      grid-template-rows: repeat(8,1fr);
   }
}

@media only screen and (max-width: 1920px) {

   .app-grid {
      max-width: 95vw;
      grid-gap: 2vw;
      .app { }
      .app img { min-width: inherit; width: 92px; }
   }
}

@media only screen and (max-width: 920px) {

   .app-grid {
      grid-gap: 5vw;

      .app { padding: 0 $gap*2 $gap*3; }
      .app img { min-width: inherit; width: 64px; }
      .app .label { font-size: 80%; font-weight: bold; bottom: 0; }
   }
}

@media only screen and (max-width: 500px) {

   .app-grid {
      grid-row-gap: 3*$gap;
      grid-column-gap: 0;
      .app:hover { background: none; } /* phones don't hover */
      .app img { }
   }
}  
